clc;
clear all;

x_spline_points=[-2.0944 -1.74533 -1.39626 -1.0472 -0.698132 -0.349066 -0.174533 0.197344 0.337395 0.490178 1.52146 2.0944;-0.0032 0.00179 0.00411 0.0041 0.00212 -0.001 -0.0031 -0.005227 -0.005435 -0.005574 -0.005435 -0.00525]; 
y_spline_points=[-2.0944 -1.22173 -0.523599 -0.349066 -0.174533 0.159149 2.0944; -0.4226 -0.4082 -0.399 -0.3976 -0.3966 -0.395264 -0.396];


%curvex=fnplt(cscvn(x_spline_points));
%curvey=fnplt(cscvn(y_spline_points));
%plot(curvex(2,:),curvex(2,:),'o')
%axis equal

steg=240;
dx=4.5742/steg;
x=0:dx:(steg*dx);
fy=cscvn(y_spline_points);
ypoints=fnval(fy,x);


dx=6.5193/steg;
x=0:dx:(steg*dx);
fx=cscvn(x_spline_points);
xpoints=fnval(fx,x);

rad=-(2/3)*pi:(pi/18):(pi/18);
kordinater=[];

j=1;

for i=1:steg;
     if j==15;
        break;
            
    elseif abs(xpoints(1,i)-rad(j))<0.009;
        kordinater(1,j)= rad(j);
        kordinater(2,j)= xpoints(2,i);
        j=j+1;         
    end
end

j=1;

for i=1:steg;
     if j==15;
        break;
            
    elseif abs(ypoints(1,i)-rad(j))<0.009;
        kordinater(3,j)= ypoints(2,i);
        j=j+1;         
    end
end

j=1;
%for investigation of knee angle change vs. change of angle  
for j=2:14;
  deltax= kordinater(2,j)-kordinater(2,(j-1)); 
  deltay=kordinater(3,j)-kordinater(3,(j-1));
  hyp=((deltax)^2+(deltay)^2)^0.5;
  deltavinkel=acos(deltax/hyp);
  kordinater(4,j)= deltavinkel*(180/pi);

end


j=1;
for j=3:14
   kordinater(5,j)=(kordinater(4,j) - kordinater(4,j-1));  
end

plot(kordinater(2,:),kordinater(3,:),'o')
axis equal
hold on

x=kordinater(2,:); y=kordinater(3,:);
%circlefit function
[xc,yc,R,a] = circfit(x,y);

plot(xc,yc,'g*')
hold on

theta = linspace(0,2*pi);
x = R*cos(theta) + xc;
y = R*sin(theta) + yc;
plot(x,y,'c')

title('Knee translation spline')
xlabel('[m] translation in x-diection')
ylabel('[m] translation in y-direction')

   
% file printing in case of cam joint use 

%fileID = fopen('kordinater.txt','w');
%for j=1:14;
%fprintf(fileID,'%6.2f %12.8f %12.8f\r\n',kordinater(1,j),kordinater(2,j),kordinater(3,j));
%end
%fclose(fileID);

%fileID = fopen('globalekordinater.txt','w');
%for j=1:14;  
%fprintf(fileID,'%6.2f %12.8f %12.8f %12.8f\r\n',kordinater(1,j),kordinater(2,j)-0.0707,kordinater(3,j)-0.0661,0.0835);
%end
%fclose(fileID);

