import xml.etree.ElementTree as ET
from os import path

#input path
path_input ={ 'gait':'C:\OpenSimWorkspace\Models\Gait2392_Simbody\gait2392_simbody.osim', 'thoracolumbar':'C:\OpenSimWorkspace\Models\Thoracolumbar_OSIM_V1\Thoracolumbar_Spine_With_RibCage.osim'}

#input: gait or thoracolumbar
model= 'gait'

tree = ET.parse(path_input[model])
root = tree.getroot()

def write_class(class_name, cont):
    with open(path.relpath(class_name + '.aml'), 'w') as f:
        f.write(cont)
    print 'Class: "' + class_name + '" written to AML file.'
    return 'done'

aml_header = '(in-package :aml)\n\n'

joint_class = "(ground-joint  :class 'coordinate-system-class\n" +\
                          'origin (list  0 0 0 )\n' +\
                          ')\n\n'

for body in root.findall('.//Body'):
    for location_in_parent in body.findall('.//location_in_parent'):
         for orientation_in_parent in body.findall('.//orientation_in_parent'):
            for parent_body in body.findall('.//parent_body'):
                x, y, z =orientation_in_parent.text.split()
                joint_class += '(' + body.attrib['name'] + '-joint  :class \'coordinate-system-class\n' + \
                "orientation (list (rotate (radians-to-degrees " + x + " ) :x-axis)(rotate (radians-to-degrees " + y + " ) :y-axis)(rotate (radians-to-degrees " + z + " ) :z-axis)(translate (list " + location_in_parent.text + " )))\n" + \
                'reference-coordinate-system ^^' + parent_body.text + '-joint \n'+\
                'display? ^^display-coord-systems?\n' +\
                'length ^^coordinate-system-length\n' +\
                ')\n\n'

class_definition ='(define-class joint-class\n' + \
                ':inherit-from (\n' + \
                'object\n' + \
                ')\n' + \
                ':properties (\n' + \
                'display-coord-systems? (default nil)\n' + \
                'coordinate-system-length 0.1\n' + \
                ')\n' + \
                ':subobjects (\n' + \
                joint_class+ \
                ')\n' + \
                ')'

aml_code = aml_header + \
        class_definition

write_class('joint_class_gait', aml_code)
