import xml.etree.ElementTree as ET
from os import path

#####################################################
# C:\OpenSimWorkspace\Models\Gait2392_Simbody\gait2392_simbody.osim
# C:\OpenSimWorkspace\Models\Thoracolumbar_OSIM_V1\Thoracolumbar_Spine_With_RibCage.osim
#####################################################

tree = ET.parse('C:\OpenSimWorkspace\Models\Thoracolumbar_OSIM_V1\Thoracolumbar_Spine_With_RibCage.osim')
root = tree.getroot()

#####################################################
# Print to shell
#####################################################

for body in root.findall('.//Body'):
    print '_______________________'
    print body.get('name')
    for geometry_file in body.findall('.//geometry_file'):
        geometry_file = geometry_file.text
        print geometry_file

 
       
#####################################################
# Write to AML file (first level: Body parts)
#####################################################

def write_class(class_name, cont):
    with open(path.relpath(class_name + '.aml'), 'a') as f:
        f.write(cont)
    print 'Class: "' + class_name + '" written to AML file.'
    return 'done'

aml_header = '(in-package :aml)\n\n'

body_web_surface_class=''
for body in root.findall('.//Body'):
    for geometry_file in body.findall('.//geometry_file'):
        geometry_file = geometry_file.text
        if geometry_file is not None:
            geometry_file= geometry_file.replace(".vtp","",1)
            body_web_surface_class += '(define-class '+ geometry_file + '-web-surface \n ' +\
                ':inherit-from(web-surface-object) \n' +\
                ':properties ( \n' +\
                r'nodes-file "C:\\PytonWorkspace\\' + geometry_file +'_points.dat" \n' +\
                r'con-file  "C:\\PytonWorkspace\\' + geometry_file +'_connectivity.dat" \n' +\
                'cleanup? nil \n' +\
                'method 2 \n' +\
                ')\n' +\
           ')\n\n' 
    
aml_code = aml_header + \
            body_web_surface_class 
write_class('web_surface_class', aml_code)
